## xen 4.20.2

=== extras/mini-os/Makefile ===
# Common Makefile for mini-os.
#
# Every architecture directory below mini-os/arch has to have a
# Makefile and a arch.mk.
#

OBJ_DIR=$(CURDIR)
TOPLEVEL_DIR=$(CURDIR)

include Config.mk

# Symlinks and headers that must be created before building the C files
GENERATED_HEADERS := include/list.h $(ARCH_LINKS) include/mini-os include/$(TARGET_ARCH_FAM)/mini-os

EXTRA_DEPS += $(GENERATED_HEADERS)

# Include common mini-os makerules.
include minios.mk

# Set tester flags
# CFLAGS += -DBLKTEST_WRITE

# Define some default flags for linking.
LDLIBS := 
APP_LDLIBS := 
LDARCHLIB := -L$(OBJ_DIR)/$(TARGET_ARCH_DIR) -l$(ARCH_LIB_NAME)
LDFLAGS_FINAL := -T $(OBJ_DIR)/$(TARGET_ARCH_DIR)/minios-$(MINIOS_TARGET_ARCH).lds $(ARCH_LDFLAGS_FINAL)

# Prefix for global API names. All other symbols are localised before
# linking with EXTRA_OBJS.
GLOBAL_PREFIX := xenos_
EXTRA_OBJS =

TARGET := mini-os

# Subdirectories common to mini-os
SUBDIRS := lib

src-$(CONFIG_BLKFRONT) += blkfront.c
src-$(CONFIG_CONSFRONT) += consfront.c
src-$(CONFIG_TPMFRONT) += tpmfront.c
src-$(CONFIG_9PFRONT) += 9pfront.c
src-$(CONFIG_TPM_TIS) += tpm_tis.c
src-$(CONFIG_TPMBACK) += tpmback.c
src-y += console.c
src-y += daytime.c
src-y += e820.c
src-y += events.c
src-$(CONFIG_FBFRONT) += fbfront.c
src-y += gntmap.c
src-y += gnttab.c
src-y += hypervisor.c
src-y += kernel.c
src-y += lock.c
src-y += main.c
src-y += mm.c
src-$(CONFIG_NETFRONT) += netfront.c
src-$(CONFIG_PCIFRONT) += pcifront.c
src-y += sched.c
src-y += shutdown.c
src-$(CONFIG_TEST) += test.c
src-$(CONFIG_BALLOON) += balloon.c
src-$(CONFIG_XENBUS) += xenbus.c

src-y += lib/ctype.c
src-y += lib/math.c
src-y += lib/printf.c
src-y += lib/stack_chk_fail.c
src-y += lib/string.c
src-y += lib/sys.c
src-y += lib/xmalloc.c
src-$(CONFIG_LIBXS) += lib/xs.c

# The common mini-os objects to build.
APP_OBJS :=
OBJS := $(patsubst %.c,$(OBJ_DIR)/%.o,$(src-y))

.PHONY: default
default: $(OBJ_DIR)/$(TARGET)

# Create special architecture specific links. The function arch_links
# has to be defined in arch.mk (see include above).
ifneq ($(ARCH_LINKS),)
$(ARCH_LINKS):
	$(arch_links)
endif

include/list.h: include/minios-external/bsd-sys-queue-h-seddery include/minios-external/bsd-sys-queue.h
	perl $^ --prefix=minios  >$@.new
	$(call move-if-changed,$@.new,$@)

# Used by stubdom's Makefile
.PHONY: links
links: $(GENERATED_HEADERS)

include/mini-os:
	ln -sf . $@

include/$(TARGET_ARCH_FAM)/mini-os:
	ln -sf . $@

.PHONY: arch_lib
arch_lib:
	$(MAKE) --directory=$(TARGET_ARCH_DIR) OBJ_DIR=$(OBJ_DIR)/$(TARGET_ARCH_DIR) || exit 1;

ifeq ($(CONFIG_LWIP),y)
# lwIP library
LWC	:= $(sort $(shell find $(LWIPDIR)/src -type f -name '*.c'))
LWC	:= $(filter-out %6.c %ip6_addr.c %ethernetif.c, $(LWC))
LWO	:= $(patsubst %.c,%.o,$(LWC))
LWO	+= $(OBJ_DIR)/lwip-arch.o
ifeq ($(CONFIG_NETFRONT),y)
LWO += $(OBJ_DIR)/lwip-net.o
endif

$(OBJ_DIR)/lwip.a: $(LWO)
	$(RM) $@
	$(AR) cqs $@ $^

OBJS += $(OBJ_DIR)/lwip.a
endif

OBJS := $(filter-out $(OBJ_DIR)/lwip%.o $(LWO), $(OBJS))

ifeq ($(libc),y)
ifeq ($(CONFIG_LIBXENTOOLCORE),y)
APP_LDLIBS += -L$(TOOLCORE_PATH) -whole-archive -lxentoolcore -no-whole-archive
LIBS += $(TOOLCORE_PATH)/libxentoolcore.a
endif
ifeq ($(CONFIG_LIBXENTOOLLOG),y)
APP_LDLIBS += -L$(TOOLLOG_PATH) -whole-archive -lxentoollog -no-whole-archive
LIBS += $(TOOLLOG_PATH)/libxentoollog.a
endif
ifeq ($(CONFIG_LIBXENEVTCHN),y)
APP_LDLIBS += -L$(EVTCHN_PATH) -whole-archive -lxenevtchn -no-whole-archive
LIBS += $(EVTCHN_PATH)/libxenevtchn.a
endif
ifeq ($(CONFIG_LIBXENGNTTAB),y)
APP_LDLIBS += -L$(GNTTAB_PATH) -whole-archive -lxengnttab -no-whole-archive
LIBS += $(GNTTAB_PATH)/libxengnttab.a
endif
ifeq ($(CONFIG_LIBXENCALL),y)
APP_LDLIBS += -L$(CALL_PATH) -whole-archive -lxencall -no-whole-archive
LIBS += $(CALL_PATH)/libxencall.a
endif
ifeq ($(CONFIG_LIBXENFOREIGNMEMORY),y)
APP_LDLIBS += -L$(FOREIGNMEMORY_PATH) -whole-archive -lxenforeignmemory -no-whole-archive
LIBS += $(FOREIGNMEMORY_PATH)/libxenforeignmemory.a
endif
ifeq ($(CONFIG_LIBXENDEVICEMODEL),y)
APP_LDLIBS += -L$(DEVICEMODEL_PATH) -whole-archive -lxendevicemodel -no-whole-archive
LIBS += $(DEVICEMODEL_PATH)/libxendevicemodel.a
endif
ifeq ($(CONFIG_LIBXENGUEST),y)
APP_LDLIBS += -L$(GUEST_PATH) -whole-archive -lxenguest -no-whole-archive
LIBS += $(GUEST_PATH)/libxenguest.a
endif
ifeq ($(CONFIG_LIBXENCTRL),y)
APP_LDLIBS += -L$(CTRL_PATH) -whole-archive -lxenctrl -no-whole-archive
LIBS += $(CTRL_PATH)/libxenctrl.a
endif
APP_LDLIBS += -lpci
APP_LDLIBS += -lz
APP_LDLIBS += -lm
LDLIBS += -lc
endif

ifneq ($(APP_OBJS)-$(lwip),-y)
OBJS := $(filter-out $(OBJ_DIR)/daytime.o, $(OBJS))
endif

$(OBJ_DIR)/$(TARGET)_app.o: $(APP_OBJS) app.lds $(LIBS)
	$(LD) -r -d $(LDFLAGS) -\( $(APP_OBJS) -T app.lds -\) $(APP_LDLIBS) --undefined main -o $@

ifneq ($(APP_OBJS),)
APP_O=$(OBJ_DIR)/$(TARGET)_app.o 
endif

# Special rule for x86 for now
$(OBJ_DIR)/arch/x86/minios-x86%.lds:  arch/x86/minios-x86.lds.S
	$(CPP) $(ASFLAGS) -P $< -o $@

$(OBJ_DIR)/$(TARGET)-kern.o: $(OBJS) arch_lib $(OBJ_DIR)/$(TARGET_ARCH_DIR)/minios-$(MINIOS_TARGET_ARCH).lds
	$(LD) -r $(LDFLAGS) $(HEAD_OBJ) $(OBJS) $(LDARCHLIB) -o $@
	# The following would be neat, but isn't supported in binutils < 2.25
	# $(OBJCOPY) --dump-section .export_symbol=$(OBJ_DIR)/syms $@
	$(OBJCOPY) --set-section-flags .export_symbol=alloc -O binary --only-section=.export_symbol $@ $(OBJ_DIR)/syms
	$(OBJCOPY) -w -G $(GLOBAL_PREFIX)* --keep-global-symbols=$(OBJ_DIR)/syms --remove-section=.export_symbol $@ $@

$(OBJ_DIR)/$(TARGET): $(OBJ_DIR)/$(TARGET)-kern.o $(APP_O)
	$(LD) -r $(LDFLAGS) $(OBJ_DIR)/$(TARGET)-kern.o $(APP_O) $(LDLIBS) -o $@.o
	$(OBJCOPY) -w -G $(GLOBAL_PREFIX)* -G _start --remove-section=.export_symbol $@.o $@.o
	$(LD) $(LDFLAGS) $(LDFLAGS_FINAL) $@.o $(EXTRA_OBJS) -o $@-debug
	strip -s $@-debug -o $@
	gzip -n -f -9 -c $@-debug >$@-debug.gz
	gzip -n -f -9 -c $@ >$@.gz

.PHONY: config
CONFIG_FILE ?= $(CURDIR)/minios-config.mk
config:
	echo "$(DEFINES-y)" >$(CONFIG_FILE)

.PHONY: clean arch_clean

arch_clean:
	$(MAKE) --directory=$(TARGET_ARCH_DIR) OBJ_DIR=$(OBJ_DIR)/$(TARGET_ARCH_DIR) clean || exit 1;

clean:	arch_clean
	for dir in $(addprefix $(OBJ_DIR)/,$(SUBDIRS)); do \
		rm -f $$dir/*.o; \
	done
	rm -f include/list.h
	rm -f $(OBJ_DIR)/*.o *~ $(OBJ_DIR)/core $(OBJ_DIR)/$(TARGET).elf $(OBJ_DIR)/$(TARGET).raw $(OBJ_DIR)/$(TARGET) $(OBJ_DIR)/$(TARGET).gz
	find . $(OBJ_DIR) -type l | xargs rm -f
	$(RM) $(OBJ_DIR)/lwip.a $(LWO)
	rm -f tags TAGS

.PHONY: testbuild
TEST_CONFIGS := $(wildcard $(CURDIR)/$(TARGET_ARCH_DIR)/testbuild/*)
testbuild:
	for arch in $(MINIOS_TARGET_ARCHS); do \
		for conf in $(TEST_CONFIGS); do \
			$(MAKE) clean; \
			MINIOS_TARGET_ARCH=$$arch MINIOS_CONFIG=$$conf $(MAKE) || exit 1; \
		done; \
	done
	$(MAKE) clean

define all_sources
     ( find . -name '*.[chS]' -print )
endef

.PHONY: cscope
cscope:
	$(all_sources) > cscope.files
	cscope -k -b -q
    
.PHONY: tags
tags:
	$(all_sources) | xargs ctags

.PHONY: TAGS
TAGS:
	$(all_sources) | xargs etags

.PHONY: gtags
gtags:
	$(all_sources) | gtags -f -

=== debian/changelog ===
xen (4.20.2-1+ub24u04.2) noble; urgency=medium

  * Non-maintainer upload.
  * HEAD @ 75013fc5c523b8a969
    x86/amd: Fold another DE_CFG edit into amd_init_de_cfg-Thu 29 Jan 2026 04:45
  - XSA-477
    0021-x86-shadow-don-t-overrun-trace_emul_write_val.diff:This is XSA-477 / CVE-2025-58150.
  - XSA-479
    0022-x86-spec-ctrl-Fix-incomplete-IBPB-flushing-during-con.diff:This is XSA-479 / CVE-2026-23553.

 -- Mark Pryor <pryorm09@gmail.com>  Thu, 29 Jan 2026 14:06:56 -0800

xen (4.20.2-1+ub24u04.1) noble; urgency=medium

  * HEAD @ 0cb467d86df393fc2c
    x86: fix incorrect return value for has_if_pschange_mc-Tue 13 Jan 2026 06:47
  * initial build of 4.20.2
  * XSA-475
    0050-x86-viridian-Enforce-bounds-check-in-vpmask_set.diff:This is XSA-475 / CVE-2025-58147.
    0051-x86-viridian-Enforce-bounds-check-in-send_ipi.diff:This is XSA-475 / CVE-2025-58148.
  * XSA-476
    0053-tools-libs-light-fix-BAR-memory-address-truncation.diff:This is XSA-476 / CVE-2025-58149.
  * qemuu: support opengl & dbus-display

 -- Mark Pryor <pryorm09@gmail.com>  Thu, 22 Jan 2026 20:28:44 -0800

xen (4.20.1-1+ub24u04.3) noble; urgency=medium

  * Non-maintainer upload.
  * HEAD @ ae992e68d3ed7a177
    CI: Create initrd fragments explicitly as root-Wed 10 Sep 2025 09:19
  * XSA-472
    0035-x86-viridian-avoid-NULL-pointer-dereference-in-update.diff:This is CVE-2025-27466 / part of XSA-472.
    0036-x86-viridian-avoid-NULL-pointer-dereference-in-viridi.diff:This is CVE-2025-58142 / part of XSA-472.
    0037-x86-viridian-protect-concurrent-modification-of-the-r.diff:This is CVE-2025-58143 / part of XSA-472.
  * XSA-473
    0038-Arm-foreign-page-handling-in-p2m_get_page_from_gfn.diff:This is CVE-2025-58144 / part of XSA-473.
    0039-Arm-adjust-locking-in-p2m_get_page_from_gfn.diff:This is CVE-2025-58145 / part of XSA-473.

 -- Mark Pryor <pryorm09@gmail.com>  Wed, 17 Sep 2025 11:11:06 -0700

xen (4.20.1-1+ub24u04.2) noble; urgency=medium

  * Non-maintainer upload.
  * HEAD @ 69568ab30622ba09a398
    x86/S3: dont lose previously collected CPU data (AMD extra)-Tue 22 Jul 2025 03:42

 -- Mark Pryor <pryorm09@gmail.com>  Tue, 22 Jul 2025 12:32:51 -0700

xen (4.20.1-1+ub24u04.1) noble; urgency=medium

  * HEAD @ 08f043965a7b1047a
    update Xen version to 4.20.1-Wed 9 Jul 2025 06:57
  * initial build of xen-4.20.1
  * XSA-471
    0138-x86-ucode-Digests-for-TSA-microcode.diff:This is part of XSA-471 / CVE-2024-36350 / CVE-2024-36357.
    0139-x86-idle-Rearrange-VERW-and-MONITOR-in-mwait_idle_wit.diff:This is part of XSA-471 / CVE-2024-36350 / CVE-2024-36357.
    0140-x86-spec-ctrl-Mitigate-Transitive-Scheduler-Attacks.diff:This is part of XSA-471 / CVE-2024-36350 / CVE-2024-36357.
  * XSA-470
    9e1309b0f037a6-x86/emul: Fix extable registration in invoke_stub-Tue 1 Jul 2025 04:57
  * all *efi blobs to usr/lib/efi, not ESP

 -- Mark Pryor <pryorm09@gmail.com>  Thu, 10 Jul 2025 13:46:09 -0700

xen (4.20.0-1+ub24u04.5) noble; urgency=medium

  * Non-maintainer upload.
  * HEAD @ ddec00769cd80a44
    x86/emul: Fix emulation of RDSEED with older toolchains-Fri 16 May 2025 13:34
  * d/control: xen-perf-hypervisor, new package
  * XSA-469
    0100-x86-guest-Remove-use-of-the-Xen-hypercall_page.diff:This is part of XSA-469 / CVE-2024-28956
    0101-x86-thunk-Mis-align-__x86_indirect_thunk_-to-mitigate.diff:This is part of XSA-469 / CVE-2024-28956
    0102-x86-thunk-Mis-align-the-RETs-in-clear_bhb_loops-to-mi.diff:This is part of XSA-469 / CVE-2024-28956
    0103-x86-stubs-Introduce-place_ret-to-abstract-away-raw-0x.diff:This is part of XSA-469 / CVE-2024-28956
    0104-x86-thunk-Build-Xen-with-Return-Thunks.diff:This is part of XSA-469 / CVE-2024-28956
    0105-x86-spec-ctrl-Synthesise-ITS_NO-to-guests-on-unaffect.diff:This is part of XSA-469 / CVE-2024-28956

 -- Mark Pryor <pryorm09@gmail.com>  Mon, 23 Jun 2025 08:42:34 -0700

xen (4.20.0-1+ub24u04.4) noble; urgency=medium

  * Non-maintainer upload.
  * HEAD @ 35cb38b2220b15e122
    x86: constrain sub-page access length in mmio_ro_emulated_write-Tue 29 Apr 2025 11:47

 -- Mark Pryor <pryorm09@gmail.com>  Tue, 29 Apr 2025 17:53:46 -0700

xen (4.20.0-1+ub24u04.3) noble; urgency=medium

  * Non-maintainer upload.
  * HEAD @ c607822b5ae946cfc2
    x86/setup: correct off-by-1 in module mapping-Thu 20 Mar 2025 04:55

 -- Mark Pryor <pryorm09@gmail.com>  Thu, 20 Mar 2025 20:04:56 -0700

xen (4.20.0-1+ub24u04.2) noble; urgency=medium

  * remove t64 names, now out-of-transition
    applies to all noble 4.20 xen packages, from here on out

 -- Mark Pryor <pryorm09@gmail.com>  Sun, 09 Mar 2025 09:16:45 -0800

xen (4.20.0-1+ub24u04.1) noble; urgency=medium

  * HEAD @ 3ad5d648cda5add395f
    Update to Xen 4.20-Tue 4 Mar 2025 08:41
  * initial build of 4.20.0
  * XSA-467
    0557-IOMMU-x86-the-bus-to-bridge-lock-needs-to-be-acquired.diff:This is XSA-467 / CVE-2025-1713.

 -- Mark Pryor <pryorm09@gmail.com>  Tue, 04 Mar 2025 17:56:03 -0800

xen (4.20~rc5-1+ub24u04.1) noble; urgency=medium

  * HEAD @ ac8198c532f4e39659d5e5
    Switch to release builds by default-Fri 21 Feb 2025 06:58

 -- Mark Pryor <pryorm09@gmail.com>  Sat, 22 Feb 2025 15:32:09 -0800

xen (4.20~rc2-1+ub24u04.1) noble; urgency=medium

  * HEAD @ 39c45caef271bc2b
    xen/arm: ffa: fix bind/unbind notification-Mon 3 Feb 2025 14:48
  * 4.20 initial rc build
  * qemuu: v9.1.0

 -- Mark Pryor <pryorm09@gmail.com>  Thu, 06 Feb 2025 12:26:43 -0800

=== debian/control ===
Source: xen
Section: kernel
Priority: optional
Maintainer: Debian Xen Team <pkg-xen-devel@lists.alioth.debian.org>
Uploaders: Guido Trotter <ultrotter@debian.org>, Bastian Blank <waldi@debian.org>, Ian Jackson <ian.jackson@eu.citrix.com>
Standards-Version: 4.6.2
Build-Depends: autotools-dev, debhelper-compat (= 13), debhelper (>> 13), dpkg-dev (>= 1.16.0~), lsb-release, python3-dev, python3-lxml, pandoc, bison, flex, bcc [i386 amd64], gcc-multilib [i386 amd64], e2fslibs-dev, iasl, seabios (>= 1.7.4-2~) [i386 amd64], libaio-dev, libfdt-dev [armhf arm64 amd64], libglib2.0-dev, liblzma-dev, libncurses5-dev, libpixman-1-dev, libyajl-dev, pkg-config, uuid-dev, zlib1g-dev, libfile-fcntllock-perl, dh-python, dh-strip-nondeterminism, dh-buildinfo, libsystemd-dev, figlet, libnl-3-dev, libnl-route-3-200, libnl-route-3-dev, checkpolicy, libnuma-dev, ghostscript, libbz2-dev, device-tree-compiler, texinfo, python3-markdown, texi2html, fig2dev, liblz4-dev, acpica-tools, libasound2-dev [linux-any], libattr1-dev, libbrlapi-dev, ninja-build, meson, libfuse3-dev, libkeyutils-dev, libcapstone-dev, libzstd-dev, python3-sphinx-rtd-theme, python3-sphinx, libglusterfs-dev, libiscsi-dev, libvirglrenderer-dev, libslirp-dev, slirp, libcap-dev [linux-any], libcap-ng-dev [linux-any], libcurl4-gnutls-dev, librdmacm-dev, liburing-dev [linux-any], libibverbs-dev, libibumad-dev, libfabric-dev, libgbm-dev, gnutls-dev, libiscsi-dev (>> 1.9.0~), libncursesw5-dev, libnfs-dev (>> 1.9.3), libcacard-dev, libpulse-dev, librados-dev [linux-any], librbd-dev [linux-any], libsasl2-dev, libsdl2-dev, libsdl2-image-dev, libseccomp-dev (>> 2.1.0) [linux-amd64 linux-i386], libspice-server-dev (>= 0.12.2~) [linux-amd64 linux-i386], libspice-protocol-dev (>= 0.12.3~) [linux-amd64 linux-i386], libusb-1.0-0-dev (>= 2:1.0.13~) [linux-any], libusbredirparser-dev (>= 0.6~) [linux-any], libssh-dev, libvdeplug-dev, libx11-dev, xfslibs-dev [linux-any], libjpeg-dev, libpng-dev, libpci3, python3-venv, liblzo2-2, liblzo2-dev, libsdl1.2debian, libsdl1.2-dev, ipxe-qemu,libepoxy-dev, libbpf-dev, libdw-dev,libibverbs-dev, libibumad-dev, libfabric-dev, libgbm-dev,libglib2.0-0t64, libpam0g-dev
XS-Python-Version: 3.11, 3.12, 3.13
XS-X-Python3-Version: >= 3.12

Package: libxenmisc4.20
Architecture: amd64 arm64 armhf i386
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Public libs for Xen
 This package contains the shared toolstack libraries for Xen.
Multi-Arch: same

Package: libxenfsutl4.20
Architecture: amd64 arm64 armhf i386
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: xen-utils-4.20 companion libs
 This package contains a depends to XenStore.  .
Multi-Arch: same

Package: libxenstore4.0
Architecture: amd64 arm64 armhf i386
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xenstore communications library for Xen
 This package contains the client library interface to XenStore.  .
Multi-Arch: same

Package: libxentoolcore1
Architecture: amd64 arm64 armhf i386
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: helper for qemu & libxenstore
 This package contains a depends to XenStore.  .
Multi-Arch: same

Package: libxen-dev
Architecture: amd64 arm64 armhf i386
Section: libdevel
Depends: libxenmisc4.20 (= ${binary:Version}), libxenstore4.0 (= ${binary:Version}), ${misc:Depends}
Description: Public headers and libs for Xen
 This package contains the public headers and static libraries for Xen.
 .
 The libxenlight library is intended as a common base for all Xen toolstack
 developers.  The libxlutil library contains additional helpers which may
 be useful to toolstack developers.
 .
 The libxenstore library allows userspace processes to interact with the
 XenStore database.  XenStore is a shared database used for interdomain
 communication of configuration and status information.  It is accessible
 to all domains running on the same Xen host.  See
 http://wiki.xen.org/wiki/XenStore for more information.
 .
 The libxenctrl and libxenguest libraries are internal libraries intended
 for use by the Xen toolstack and are not intended to be used directly.
 Toolstack authors should use libxenlight.
Multi-Arch: same

Package: xenstore-utils
Architecture: amd64 arm64 armhf i386
Section: admin
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: xen-utils-common (<= 3.1.0-1)
Description: Xenstore command line utilities for Xen
 This package contains command line utilities for interacting with
 XenStore.
 .
 XenStore is a shared database used for interdomain communication of
 configuration and status information.  It is accessible to all domains
 running on the same Xen host.  See http://wiki.xen.org/wiki/XenStore for
 more information.
 .
 In the common case these tools are used by the Xen toolstack running in
 domain0 (or a driver domain) however they may also be used in a guest
 domain to support local scripting which wants to communicate via XenStore.

Package: xen-utils-common
Architecture: all
Depends: lsb-base, python3, udev, xenstore-utils, ${misc:Depends}
Description: Xen administrative tools - common files
 The userspace tools to manage a system virtualized through the Xen virtual
 machine monitor.
 .
 This package is only required on the host system (Domain 0) and not on the
 virtual guest systems (Domain U).

Package: xen-utils-4.20
Architecture: amd64 arm64 armhf i386
Provides: xen-utils
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, xen-utils-common (>= ${source:Version})
Recommends: bridge-utils, libc6-xen [i386], xen-hypervisor-4.20, qemuu
Suggests: seabios [i386 amd64], grub-xen-host [i386 amd64]
Description: XEN administrative tools
 The userspace tools to manage a system virtualized through the XEN virtual
 machine monitor.
 .
 qemu-utils and seabios are neded for "Xen HVM" (amd64 and i386)
Built-Using: ${misc:Built-Using}

Package: qemuu
Architecture: amd64 arm64 armhf i386
Section: admin
Provides: qemu-system-i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: qemu-system-i386 (9.1.0/xen-4.20) with 9pfs support
 Warning: This is a custom testing build of Xen.
Build-Profiles: <!noqemu>
Installed-Size: $(du -ks deb | cut -f1)

Package: qemut
Architecture: amd64 arm64 armhf i386
Section: admin
Provides: qemu-dm
Depends: ${shlibs:Depends}, ${misc:Depends}, ipxe-qemu
Description: qemu-dm (0.10.2/xen-4.20) with 9pfs support
 Warning: This is a custom testing build of Xen.
Build-Profiles: <!noqemu>
Installed-Size: $(du -ks deb | cut -f1)

Package: xen-hypervisor-4.20-amd64
Architecture: amd64 i386
Provides: xen-hypervisor, xen-hypervisor-4.20, xen-hypervisor-amd64
Depends: ${misc:Depends}
Recommends: xen-utils-4.20
Description: Xen Hypervisor on AMD64
 The hypervisor is the "core" for XEN itself.  It gets booted by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.
 .
 In order to boot a XEN system along with this package you also need a
 kernel specifically crafted to work as the Domain 0, mediating hardware
 access for XEN itself.

Package: xen-perf-hypervisor-4.20-amd64
Architecture: amd64
Provides: xen-perf-hypervisor, xen-perf-hypervisor-4.20, xen-perf-hypervisor-amd64
Depends: ${misc:Depends}
Recommends: xen-utils-4.20
Description: Xen Perf-Hypervisor on AMD64
 The perf-hypervisor is for debug/perf.  It gets booted by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.


Package: xen-system-amd64
Architecture: amd64 i386
Provides: xen-system
Depends: xen-hypervisor-4.20-amd64, xen-utils-4.20, ${misc:Depends}
Description: Xen System on AMD64 (meta-package)
 This package depends on the latest Xen hypervisor for use on AMD64 and the
 Xen utils.

Package: xen-hypervisor-4.20-arm64
Architecture: arm64
Provides: xen-hypervisor, xen-hypervisor-4.20, xen-hypervisor-arm64
Depends: ${misc:Depends}
Recommends: xen-utils-4.20
Description: Xen Hypervisor on ARM64
 The hypervisor is the "core" for XEN itself.  It gets booted by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.
 .
 In order to boot a XEN system along with this package you also need a
 kernel specifically crafted to work as the Domain 0, mediating hardware
 access for XEN itself.

Package: xen-system-arm64
Architecture: arm64
Provides: xen-system
Depends: xen-hypervisor-4.20-arm64, xen-utils-4.20, ${misc:Depends}
Description: Xen System on ARM64 (meta-package)
 This package depends on the latest Xen hypervisor for use on ARM64 and the
 Xen utils.

Package: xen-hypervisor-4.20-armhf
Architecture: armhf
Provides: xen-hypervisor, xen-hypervisor-4.20, xen-hypervisor-armhf
Depends: ${misc:Depends}
Recommends: xen-utils-4.20
Description: Xen Hypervisor on ARMHF
 The hypervisor is the "core" for XEN itself.  It gets booted by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.
 .
 In order to boot a XEN system along with this package you also need a
 kernel specifically crafted to work as the Domain 0, mediating hardware
 access for XEN itself.

Package: xen-system-armhf
Architecture: armhf
Provides: xen-system
Depends: xen-hypervisor-4.20-armhf, xen-utils-4.20, ${misc:Depends}
Description: Xen System on ARMHF (meta-package)
 This package depends on the latest Xen hypervisor for use on ARMHF and the
 Xen utils.

## xen 4.20.2%2B7

=== xen/Makefile ===
# $(lastword,) for GNU Make older than 3.81
lastword = $(word $(words $(1)),$(1))
this-makefile := $(call lastword,$(MAKEFILE_LIST))

# This is the correct place to edit the build version.
# All other places this is stored (eg. compile.h) should be autogenerated.
export XEN_VERSION       = 4
export XEN_SUBVERSION    = 20
export XEN_EXTRAVERSION ?= .3-pre$(XEN_VENDORVERSION)
export XEN_FULLVERSION   = $(XEN_VERSION).$(XEN_SUBVERSION)$(XEN_EXTRAVERSION)
-include xen-version

export XEN_WHOAMI	?= $(USER)
ifeq ($(origin XEN_DOMAIN), undefined)
export XEN_DOMAIN	:= $(shell ([ -x /bin/dnsdomainname ] && /bin/dnsdomainname) || ([ -x /bin/domainname ] && /bin/domainname || echo [unknown]))
endif
ifeq ($(origin XEN_BUILD_HOST), undefined)
export XEN_BUILD_HOST	:= $(shell hostname)
endif
# XEN_BUILD_DATE and XEN_BUILD_TIME are set further down, as they depend on
# Config.mk for SOURCE_DATE_EPOCH handling.

# Best effort attempt to find a python interpreter, defaulting to Python 3 if
# available.  Fall back to just `python`.
PYTHON_INTERPRETER	:= $(word 1,$(shell command -v python3 || command -v python || command -v python2) python)
export PYTHON		?= $(PYTHON_INTERPRETER)

export CHECKPOLICY	?= checkpolicy

$(if $(filter __%, $(MAKECMDGOALS)), \
    $(error targets prefixed with '__' are only for internal use))

# That's our default target when none is given on the command line
PHONY := __all
__all:

# Do not use make's built-in rules and variables
MAKEFLAGS += -rR

EFI_MOUNTPOINT ?= $(BOOT_DIR)/efi

# Allow someone to change their config file
export KCONFIG_CONFIG ?= .config

export TARGET := xen

.PHONY: dist
dist: install

ifneq ($(root-make-done),y)
# section to run before calling Rules.mk, but only once.

ifneq ($(origin crash_debug),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable crash_debug now.")
endif
ifeq ($(origin debug),command line)
$(warning "You must use e.g. 'make menuconfig' to enable/disable debug now.")
endif
ifneq ($(origin frame_pointer),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable frame_pointer now.")
endif
ifneq ($(origin kexec),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable kexec now.")
endif
ifneq ($(origin lock_profile),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable lock_profile now.")
endif
ifneq ($(origin perfc),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable perfc now.")
endif
ifneq ($(origin verbose),undefined)
$(error "You must use e.g. 'make menuconfig' to enable/disable verbose now.")
endif

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing will be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.
#
# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE := $(V)
endif
ifndef KBUILD_VERBOSE
    KBUILD_VERBOSE := 0
endif

ifeq ($(KBUILD_VERBOSE),1)
    quiet :=
    Q :=
else
    quiet := quiet_
    Q := @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(filter-out --%,$(MAKEFLAGS))),)
    quiet := silent_
endif

export quiet Q KBUILD_VERBOSE

# $(realpath,) for GNU Make older than 3.81
realpath = $(wildcard $(foreach file,$(1),$(shell cd -P $(dir $(file)) && echo "$$PWD/$(notdir $(file))")))

ifeq ("$(origin O)", "command line")
    KBUILD_OUTPUT := $(O)
endif

ifneq ($(KBUILD_OUTPUT),)
# Make's built-in functions such as $(abspath ...), $(realpath ...) cannot
# expand a shell special character '~'. We use a somewhat tedious way here.
abs_objtree := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) && pwd)
$(if $(abs_objtree),, \
     $(error failed to create output directory "$(KBUILD_OUTPUT)"))

# $(realpath ...) resolves symlinks
abs_objtree := $(call realpath,$(abs_objtree))
else
abs_objtree := $(CURDIR)
endif

ifeq ($(abs_objtree),$(CURDIR))
# Suppress "Entering directory ..." unless we are changing the work directory.
MAKEFLAGS += --no-print-directory
else
need-sub-make := 1
endif

abs_srctree := $(call realpath,$(dir $(this-makefile)))

ifneq ($(words $(subst :, ,$(abs_srctree))), 1)
$(error source directory cannot contain spaces or colons)
endif

ifneq ($(abs_srctree),$(abs_objtree))
# Look for make include files relative to root of kernel src
#
# This does not become effective immediately because MAKEFLAGS is re-parsed
# once after the Makefile is read. We need to invoke sub-make.
MAKEFLAGS += --include-dir=$(abs_srctree)
need-sub-make := 1
endif

export abs_srctree abs_objtree
export root-make-done := y

ifeq ($(need-sub-make),1)

PHONY += $(MAKECMDGOALS) __sub-make

$(filter-out $(this-makefile), $(MAKECMDGOALS)) __all: __sub-make
	@:

# Invoke a second make in the output directory, passing relevant variables
__sub-make:
	$(Q)$(MAKE) -C $(abs_objtree) -f $(abs_srctree)/Makefile $(MAKECMDGOALS)

endif # need-sub-make
endif # root-make-done

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(need-sub-make),)

# Do not print "Entering directory ...",
# but we want to display it when entering to the output directory
# so that IDEs/editors are able to understand relative filenames.
MAKEFLAGS += --no-print-directory

ifeq ($(abs_srctree),$(abs_objtree))
    # building in the source tree
    srctree := .
    building_out_of_srctree :=
else
    ifeq ($(abs_srctree)/,$(dir $(abs_objtree)))
        # building in a subdirectory of the source tree
        srctree := ..
    else
        srctree := $(abs_srctree)
    endif
    building_out_of_srctree := 1
endif

objtree := .
VPATH := $(srctree)

export srctree objtree VPATH

export XEN_ROOT := $(abs_srctree)/..

# To make sure we do not include .config for any of the *config targets
# catch them early, and hand them over to tools/kconfig/Makefile

clean-targets := %clean
no-dot-config-targets := $(clean-targets) \
                         uninstall debug cloc \
                         cscope TAGS tags gtags \
                         xenversion

config-build    := n
need-config     := y

ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
    ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
        need-config := n
    endif
endif

ifneq ($(filter %config,$(MAKECMDGOALS)),)
    config-build := y
endif

include scripts/Kbuild.include

# Don't break if the build process wasn't called from the top level
# we need XEN_TARGET_ARCH to generate the proper config
include $(XEN_ROOT)/Config.mk

# Set ARCH/SRCARCH appropriately.

ARCH := $(XEN_TARGET_ARCH)
SRCARCH := $(shell echo $(ARCH) | \
    sed -e 's/x86.*/x86/' -e 's/arm\(32\|64\)/arm/g' \
        -e 's/riscv.*/riscv/g' -e 's/ppc.*/ppc/g')
export ARCH SRCARCH

ifeq ($(origin XEN_BUILD_DATE), undefined)
export XEN_BUILD_DATE	:= $(call date)
endif
ifeq ($(origin XEN_BUILD_TIME), undefined)
export XEN_BUILD_TIME	:= $(call date,"+%T")
endif

export CONFIG_SHELL := $(SHELL)
export CC CXX LD NM OBJCOPY OBJDUMP ADDR2LINE
export YACC = $(if $(BISON),$(BISON),bison)
export LEX = $(if $(FLEX),$(FLEX),flex)

# Default file for 'make defconfig'.
# May be overruled on the command line or set in the environment.
export KBUILD_DEFCONFIG ?= $(ARCH)_defconfig

# Copy CFLAGS generated by "Config.mk" so they can be reused later without
# reparsing Config.mk by e.g. arch/x86/boot/.
export XEN_TREEWIDE_CFLAGS := $(CFLAGS)

# CLANG_FLAGS needs to be calculated before calling Kconfig
ifneq ($(shell $(CC) --version 2>&1 | head -n 1 | grep clang),)
CLANG_FLAGS :=

ifeq ($(SRCARCH),x86)
# The tests to select whether the integrated assembler is usable need to happen
# before testing any assembler features, or else the result of the tests would
# be stale if the integrated assembler is not used.

# Older clang's built-in assembler doesn't understand .skip with labels:
# https://bugs.llvm.org/show_bug.cgi?id=27369
t1 = $(call as-insn,$(CC),".L0: .L1: .skip (.L1 - .L0)",,-no-integrated-as)

# Check whether clang asm()-s support .include.
t2 = $(call as-insn,$(CC) -I$(srctree)/arch/x86/include,".include \"asm/asm-defns.h\"",,-no-integrated-as)

# Check whether clang keeps .macro-s between asm()-s:
# https://bugs.llvm.org/show_bug.cgi?id=36110
t3 = $(call as-insn,$(CC),".macro FOO;.endm"$(close); asm volatile $(open)".macro FOO;.endm",-no-integrated-as)

CLANG_FLAGS += $(call or,$(t1),$(t2),$(t3))
endif

CLANG_FLAGS += -Werror=unknown-warning-option
CFLAGS += $(CLANG_FLAGS)
export CLANG_FLAGS
endif

export XEN_HAS_CHECKPOLICY := $(call success,$(CHECKPOLICY) -h 2>&1 | grep -q xen)

# ===========================================================================
# Rules shared between *config targets and build targets

PHONY += tools_fixdep
tools_fixdep:
	$(Q)$(MAKE) $(build)=tools tools/fixdep

PHONY += outputmakefile
# Before starting out-of-tree build, make sure the source tree is clean.
# outputmakefile generates a Makefile in the output directory, if using a
# separate output directory. This allows convenient use of make in the
# output directory.
# At the same time when output Makefile generated, generate .gitignore to
# ignore whole output directory

quiet_cmd_makefile = GEN     Makefile
cmd_makefile = { \
    echo "\# Automatically generated by $(srctree)/Makefile: don't edit"; \
    echo "include $(srctree)/Makefile"; \
    } > Makefile

outputmakefile:
ifdef building_out_of_srctree
	$(Q)if [ -f $(srctree)/.config -o \
		 -d $(srctree)/include/config -o \
		 -d $(srctree)/include/generated ]; then \
		echo >&2 "***"; \
		echo >&2 "*** The source tree is not clean, please run 'make$(if $(findstring command line, $(origin XEN_TARGET_ARCH)), XEN_TARGET_ARCH=$(XEN_TARGET_ARCH)) distclean'"; \
		echo >&2 "*** in $(abs_srctree)";\
		echo >&2 "***"; \
		false; \
	fi
	$(Q)ln -fsn $(srctree) source
	$(call cmd,makefile)
	$(Q)test -e .gitignore || \
	{ echo "# this is build directory, ignore it"; echo "*"; } > .gitignore
endif

ifeq ($(config-build),y)
# ===========================================================================
# *config targets only - make sure prerequisites are updated, and descend
# in tools/kconfig to make the *config target

# Create a file for KCONFIG_ALLCONFIG which depends on the environment.
# This will be use by kconfig targets allyesconfig/allmodconfig/allnoconfig/randconfig
filechk_kconfig_allconfig = \
    $(if $(findstring n,$(XEN_HAS_CHECKPOLICY)), echo 'CONFIG_XSM_FLASK_POLICY=n';) \
    $(if $(KCONFIG_ALLCONFIG), cat $(KCONFIG_ALLCONFIG);) \
    :

.allconfig.tmp: FORCE
	set -e; { $(call filechk_kconfig_allconfig); } > $@

config: tools_fixdep outputmakefile FORCE
	$(Q)$(MAKE) $(build)=tools/kconfig $@

# Config.mk tries to include .config file, don't try to remake it
%/.config: ;

%config: .allconfig.tmp tools_fixdep outputmakefile FORCE
	$(Q)$(MAKE) $(build)=tools/kconfig KCONFIG_ALLCONFIG=$< $@

else # !config-build

ifeq ($(need-config),y)
-include include/config/auto.conf
# Read in dependencies to all Kconfig* files, make sure to run syncconfig if
# changes are detected.
-include include/config/auto.conf.cmd

# Allow people to just run `make` as before and not force them to configure

## xen 4.20.2%2B7-g1badcf5035

=== debian/changelog ===
xen (4.20.2+7-g1badcf5035-0+deb13u1) trixie-security; urgency=medium

  Significant changes:
  * Update to new upstream version 4.20.2+7-g1badcf5035, which also contains
    security fixes for the following issues:
    (Closes: #1105193) (Closes: #1120075)
    - x86: Indirect Target Selection
      XSA-469 CVE-2024-28956
    - x86: Incorrect stubs exception handling for flags recovery
      XSA-470 CVE-2025-27465
    - x86: Transitive Scheduler Attacks
      XSA-471 CVE-2024-36350 CVE-2024-36357
    - Multiple vulnerabilities in the Viridian interface
      XSA-472 CVE-2025-27466 CVE-2025-58142 CVE-2025-58143
    - Arm issues with page refcounting
      XSA-473 CVE-2025-58144 CVE-2025-58145
    - x86: Incorrect input sanitisation in Viridian hypercalls
      XSA-475 CVE-2025-58147 CVE-2025-58148
    - Incorrect removal of permissions on PCI device unplug
      XSA-476 CVE-2025-58149
  * Note that the following XSA are not listed, because...
    - XSA-468 applies to Windows PV drivers
    - XSA-474 applies to XAPI which is not included in Debian

  Packaging minor fixes and improvements:
  * debian/salsa-ci.yml: adjust for trixie and new salsa-ci pipeline

 -- Maximilian Engelhardt <maxi@daemonizer.de>  Sun, 30 Nov 2025 16:57:07 +0100
